#    Written by Mark Mayfield. MMMC performs a variety of multimedia conversions.
#    Copyright (C) 2012  Mark Mayfield
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import gtk, re, os, aud_converter, merge, pwd, settings, sys, subprocess, math

home = pwd.getpwuid(os.getuid()).pw_dir
try: 
    os.stat(home + '/.MMMC')
except:
    cmd = "mkdir ~/.MMMC \n touch ~/.MMMC/settings.dat \n touch ~/.MMMC/file.dat \n echo page 0 > ~/.MMMC/settings.dat \n echo audvidformat mp3 >> ~/.MMMC/settings.dat \n echo audaudformat mp3 >> ~/.MMMC/settings.dat \n echo audvidfile >> ~/.MMMC/settings.dat \n echo audaudfile >> ~/.MMMC/settings.dat \n echo splitfile >> ~/.MMMC/settings.dat"
    os.system(cmd)


class NotebookExample:

    def appendfile(self, widget):
	setp = 'merge'
	self.file_select(widget, setp)

    def	file_select(self, widget, setp):
	dialog = gtk.FileChooserDialog("Select File...",None,gtk.FILE_CHOOSER_ACTION_OPEN,
		(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
	dialog.set_default_response(gtk.RESPONSE_OK)

	filter = gtk.FileFilter()
	filter.set_name("All files")
	filter.add_pattern("*")
	dialog.add_filter(filter)

	vidfilter = gtk.FileFilter()
	imagefilter = gtk.FileFilter()
	vidfilter.set_name("Video Files")
	imagefilter.add_mime_type("image/png")
	imagefilter.add_mime_type("image/jpeg")
	imagefilter.add_mime_type("image/gif")
	vidfilter.add_pattern("*.flv")
	vidfilter.add_pattern("*.avi")
	vidfilter.add_pattern("*.mkv")
	vidfilter.add_pattern("*.ogg")
	vidfilter.add_pattern("*.mp4")
	vidfilter.add_pattern("*.mpeg")
	vidfilter.add_pattern("*.rmvb")
	vidfilter.add_pattern("*.mpg")
	audfilter = gtk.FileFilter()
	audfilter.set_name("Audio Files")
	audfilter.add_pattern("*.mp3")
	audfilter.add_pattern("*.aac")
	audfilter.add_pattern("*.ogg")
	audfilter.add_pattern("*.mpc")
	audfilter.add_pattern("*.wav")
	audfilter.add_pattern("*.flac")
	dialog.add_filter(audfilter)
	dialog.add_filter(vidfilter)
	if 'audaud' in setp:
		dialog.set_filter(audfilter)
	elif 'merge' in setp or 'split' in setp or 'audvid' in setp:
		dialog.set_filter(vidfilter)

	response = dialog.run()
	if response == gtk.RESPONSE_OK:
		print dialog.get_filename(), 'selected'
		value = dialog.get_filename()
		if 'merge' in setp:
			settings.writevar2(value)
			value += ' \n'
			self.textbuffer.insert_at_cursor(value)
		elif 'split' in setp:
			self.splitentry.set_text(value)
			var = 'splitfile'
			settings.writevar(var, value)
		elif 'audvid' in setp:
			self.audvidentry.set_text(value)
			var = 'audvidfile'
			settings.writevar(var,value)
		elif 'audaud' in setp:
			self.audaudentry.set_text(value)
			var = 'audaudfile'
			settings.writevar(var,value)	
	elif response == gtk.RESPONSE_CANCEL:
		print 'Closed, no files selected'
	dialog.destroy()
	if 'audvid' in setp:
		var = 'page'
		value ='1'
	elif 'audaud' in setp:
		var = 'page'
		value ='2'
	elif 'merge' in setp:
		var = 'page'
		value ='4'
	elif 'split' in setp:
		var = 'page'
		value ='5'
	settings.writevar(var, value)

    def splitfile(self, widget):
	setp = 'split'
	self.file_select(widget, setp)

    def split(self, widget):
	hours = int(self.entry2.get_text())
	minutes = int(self.entry3.get_text())
	total = (hours*60)+minutes
	cmd="mplayer -vo null -ao null -frames 0 -identify " + re.escape(self.splitentry.get_text()) + " | grep ID_LENGTH | cut -f 2 -d ="
	run = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
	for line in run.stdout.readlines():
		if line != "":
			length = re.sub("\n", '', line)
	length = int(math.ceil(float(length)/60))
	if total > 0:
		base, ext = os.path.split(re.escape(self.splitentry.get_text()))
		newname2 = re.sub('[^.]+$', '',ext)
		newname3 = re.sub('\.', '',newname2)
		hourp = 00
		minp = 00
		count = 0
		part = 1
		while ( count < length ):
			cmd = 'mencoder ' + re.escape(self.splitentry.get_text()) + ' -oac mp3lame -ovc copy -ss ' + str(hourp) + ':' + str(minp) + ':00 -endpos ' + str(hours) + ':' + str(minutes) + ':00 -o ' + home + '/Desktop/' + newname3 + '_part_' + str(part) + '.avi 2>' + home + '/errors.txt'
			os.system(cmd)	
			count += total
			part += 1
			minp += total
			hourp = hourp + minp/60
			minp = minp%60
		self.window.destroy()
		self.__init__()

    def clear(self, widget):
	output=''
	FILE = open(home + '/.MMMC/file.dat', 'w')
	FILE.write(output)
	FILE.close
	self.textbuffer.set_text('')

    def audaud(self, widget):
	contype = 'audaud'
	aud_converter.aud_convert(contype)

    def convert(self, widget):
	FILE = open(home + '/.MMMC/settings.dat', 'r')
	for line in FILE.readlines():
		if 'audvidfile' in line:
			filename = re.escape(re.sub('audvidfile ', '',line))
		elif 'audvidformat' in line:
			format = line.split()[-1]
	FILE.close()
	base, ext = os.path.split(filename)
	name2 = re.sub('[^.]+$', '',ext) + 'wav'
	cmd = 'mplayer -nocorrect-pts -vc null -vo null -ao pcm:fast:file=' + home + '/Desktop/' + name2 + ' ' + filename + ' 2>' + home + '/errors.txt'
	os.system(cmd)
	contype = 'audvid'
	aud_converter.aud_convert(contype)

    def vid_file_select(self, widget):
	setp = 'audvid'
	self.file_select(widget, setp)

    def aud_file_select(self, widget):
	setp = 'audaud'
	self.file_select(widget, setp)

    def callback(self, widget, data=None):
        output = "%s was toggled %s" % (data, ("OFF", "ON")[widget.get_active()])
	if "ON" in output:
		var = 'audvidformat'
		value = re.sub('was toggled ON', '', output)
		settings.writevar(var, value)

    def audformback(self, widget, data=None):
        output = "%s was toggled %s" % (data, ("OFF", "ON")[widget.get_active()])
	if "ON" in output:
		var = 'audaudformat'
		value = re.sub('was toggled ON', '', output)
		settings.writevar(var, value)

    def delete(self, widget, event=None):
	var='audvidfile'
	value=''
	settings.writevar(var,value)
	var='audaudfile'
	value=''
	settings.writevar(var,value)
	var='splitfile'
	value=''
	settings.writevar(var,value)
	var = 'page'
	value= '0'
	settings.writevar(var, value)
	self.clear(widget)
        gtk.main_quit()

    def __init__(self):
	
	FILE = open(home + '/.MMMC/settings.dat', 'r')
	for line in FILE.readlines():
		if 'audvidformat' in line:
			format = line.split()[-1]
		if 'audaudformat' in line:
			audaudformat = line.split()[-1]
	FILE.close()

        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.window.set_title("MMMC - Mark's Multi Media Converter")
        self.window.connect("delete_event", self.delete)
        self.window.set_border_width(10)

        table = gtk.Table(3,6)
        self.window.add(table)

        # Create a new self.notebook, place the position of the tabs
        self.notebook = gtk.Notebook()
        self.notebook.set_tab_pos(gtk.POS_TOP)
        table.attach(self.notebook, 0,6,0,1)
        self.notebook.show()
	self.show_tabs = True
	self.show_border = True

        bufferf = "Mark's Multi Media Converter"
        bufferl = "MMMC"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)

	file_name = sys.path[0] + "/Multimedia.png"
        pixbuf = gtk.gdk.pixbuf_new_from_file(file_name)
        pixmap, mask = pixbuf.render_pixmap_and_mask()
      	image = gtk.Image()
      	image.set_from_pixmap(pixmap, mask)

	bigbox = gtk.VBox()
	vbox = gtk.VBox()
	hbox=gtk.HBox()
	hbox.pack_start(image)
	bigbox.pack_start(vbox)
	bigbox.pack_start(hbox)
	

	self.frame.add(bigbox)        
	self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Audio From Video"
	self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
        button = gtk.Button("Choose Video File")
	button.connect("clicked", self.vid_file_select)
	filename = ""	

	button2 = gtk.Button("Extract and Convert")
	button2.connect("clicked", self.convert)
	self.audvidentry = gtk.Entry()

	bigbox = gtk.VBox()
	hbox = gtk.HBox()
	hbox2 = gtk.HBox()
	hbox.pack_start(self.audvidentry, padding=10)
	hbox2.pack_start(button, padding=10)
	hbox2.pack_start(button2, padding=10)
	bigbox.pack_start(hbox, padding=10)
	bigbox.pack_start(hbox2, padding=10)
	box0 = gtk.VBox()

        box1 = gtk.VBox(False, 0)
        box0.pack_start(box1)
        box1.show()

        box2 = gtk.HBox(False, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, True, True, 0)
        box2.show()

        button = gtk.RadioButton(None, "mp3")
        button.connect("toggled", self.callback, "mp3")
	if "mp3" in format:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "aac")
        button.connect("toggled", self.callback, "aac")
	if "aac" in format:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "ogg")
        button.connect("toggled", self.callback, "ogg")
	if "ogg" in format:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "mpc")
        button.connect("toggled", self.callback, "mpc")
	if "mpc" in format:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "flac")
        button.connect("toggled", self.callback, "flac")
	if "flac" in format:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()


        box2 = gtk.VBox(False, 10)
        box2.set_border_width(25)
        box1.pack_start(box2, False, True, 0)
        box2.show()

        button.set_flags(gtk.CAN_DEFAULT)
        button.show()
        box0.show()
	bigbox.pack_start(box0)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Audio to Audio"

	self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
        button = gtk.Button("Click To Choose Audio File")
	button.connect("clicked", self.aud_file_select)

	button2 = gtk.Button("Convert")
	button2.connect("clicked", self.audaud)
	self.audaudentry = gtk.Entry()

	bigbox = gtk.VBox()
	vbox = gtk.VBox()
	vbox.pack_start(self.audaudentry, padding=10)
	vbox.pack_start(button, padding=10)
	hbox = gtk.HBox()
	hbox.pack_start(vbox, padding=10)
	hbox.pack_start(button2, padding=10)
	bigbox.pack_start(hbox, padding=10)
	box0 = gtk.VBox()

        box1 = gtk.VBox(False, 0)
        box0.pack_start(box1)
        box1.show()

        box2 = gtk.HBox(False, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, True, True, 0)
        box2.show()

        button = gtk.RadioButton(None, "mp3")
        button.connect("toggled", self.audformback, "mp3")
	if "mp3" in audaudformat:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "aac")
        button.connect("toggled", self.audformback, "aac")
	if "aac" in audaudformat:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "ogg")
        button.connect("toggled", self.audformback, "ogg")
	if "ogg" in audaudformat:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "mpc")
        button.connect("toggled", self.audformback, "mpc")
	if "mpc" in audaudformat:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "flac")
        button.connect("toggled", self.audformback, "flac")
	if "flac" in audaudformat:
        	button.set_active(True)
        box2.pack_start(button, True, True, 0)
        button.show()


        box2 = gtk.VBox(False, 10)
        box2.set_border_width(25)
        box1.pack_start(box2, False, True, 0)
        box2.show()

        button.set_flags(gtk.CAN_DEFAULT)
        button.show()
        box0.show()
	bigbox.pack_start(box0)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Merge Video"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
	
	bigbox = gtk.VBox()
	bigbox.set_border_width(15)
	smallbox = gtk.HBox()
	smallbox.set_border_width(25)
	sw = gtk.ScrolledWindow()
	sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	entrymerge = gtk.TextView()
	entrymerge.set_editable(False)
	self.textbuffer = entrymerge.get_buffer()
	sw.add(entrymerge)
	sw.show()
	entrymerge.show()
	bigbox.pack_start(sw, padding=10)
	bigbox.show_all()
	entrymerge.set_buffer(self.textbuffer)
	button = gtk.Button("Click To Add Video to List")
	button.connect("clicked", self.appendfile)
	button2 = gtk.Button("Clear Selections")
	button2.connect("clicked", self.clear)
	button3 = gtk.Button("Merge Video Files")
	button3.connect("clicked", merge.filechoose)
	smallbox.pack_start(button)
	smallbox.pack_start(button2)
	smallbox.pack_start(button3)
	smallbox.show_all()
	bigbox.pack_start(smallbox)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Split Video"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)

	bigbox=gtk.VBox()
	box = gtk.HBox()
	box2 = gtk.HBox()
	button = gtk.Button("Click To Choose Video File")
	button.connect("clicked", self.splitfile)
	self.splitentry = gtk.Entry()
	self.splitentry.set_width_chars(50)
	label1 = gtk.Label("File:")
	box.pack_start(label1, expand=False, padding = 10)
	box.pack_start(self.splitentry)
	box.pack_start(button, padding=10)
	box.show_all()
	hourbox = gtk.HBox()
	minutebox = gtk.HBox()
	splitbox = gtk.HBox()
	vertbox = gtk.HBox()
	label = gtk.Label("Enter hours:")
	self.entry2 = gtk.Entry()
	self.entry2.insert_text('00')
	self.entry2.set_width_chars(3)
	label2 = gtk.Label("Enter minutes:")
	self.entry3 = gtk.Entry()
	self.entry3.insert_text('00')
	self.entry3.set_width_chars(3)
	label.show()
	label2.show()
	button2 = gtk.Button("                                             Split  Video                                                ")
	button2.connect("clicked", self.split)
	splitbox.pack_start(button2, padding=10)
	splitbox.show_all()
	hourbox.pack_start(label, expand=False)
	hourbox.pack_start(self.entry2, padding=10)
	minutebox.pack_start(label2, expand=False)
	minutebox.pack_start(self.entry3, padding=10)
	vertbox.pack_start(hourbox)
	vertbox.pack_start(minutebox, padding=10)
	hourbox.show_all()
	minutebox.show_all()
	box2.pack_start(vertbox, padding=10)
	box2.pack_start(splitbox)
	box2.show_all()
	bigbox.pack_start(box, padding=10)
	bigbox.pack_start(box2, padding=10)
	bigbox.show_all()
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	FILE = open(home + '/.MMMC/settings.dat', 'r')
	for line in FILE.readlines():
		if 'page' in line:
			page = line.split()[-1]
	FILE.close()

	if "0" in page:
        	self.notebook.set_current_page(0)
	elif "1" in page:
        	self.notebook.set_current_page(1)
	elif "2" in page:
        	self.notebook.set_current_page(2)
	elif "3" in page:
        	self.notebook.set_current_page(3)
	elif "4" in page:
        	self.notebook.set_current_page(4)

        button = gtk.Button("close")
        button.connect("clicked", self.delete)
	button.set_border_width(25)
        table.attach(button, 0,1,1,2)
        button.show()

        table.show()
        self.window.show()

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    NotebookExample()
    main()

